#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# Time Drive - based on duplicity - Encrypted bandwidth efficient backup
# Requires Duplicity Version 0.6.02 released July 08, 2009
#
# Copyright 2009 Rob Oakes	<LyX-Devel@oak-tree>

from PyQt4 import QtCore
from PyQt4 import QtGui
from PyQt4 import uic

from timedrive.utils import gui_utils
from timedrive.background import testconnectionurl

class SettingsDialog(QtGui.QDialog, testconnectionurl.TestConnectionControl):
	"""
	Settings Dialog Class: global definition of a time-drive settings class
	"""
	
	def __init__(self, parent = None):
		"""
		Initialization function for SettingsDialog
		
		@type parent: QDialog Object
		@param parent:
		"""
		super(SettingsDialog, self).__init__(parent)
		uic.properties.Properties._string = gui_utils.translate
		
	def getExcludeTreeItem(self, excludeItem):
		"""
		Returns excludeTreeItem
		
		@type excludeItem: ExcludeItem Object
		@param excludeItem:
		"""
		excludeIcon = QtGui.QIcon(QtGui.QPixmap(":/PNG/Resources/Remove-Snapshot.png"))
		excludeTreeItem = QtGui.QTreeWidgetItem([QtCore.QString(excludeItem.Item)])
		excludeTreeItem.setIcon(0, excludeIcon)
		return excludeTreeItem