#!/usr/bin/env python
#
# Time Drive - based on duplicity - Encrypted bandwidth efficient backup.
#
# Copyright 2009 Rob Oakes	<LyX-Devel@oak-tree>

from timedrive.backupsettings.settings import Settings
import duplicity_interface
from __init__ import *

def CombineBackups(stringTime, folder):
	duplicity_interface.log.setup()
	
	backupTime1 = time_String2Int(str(stringTime)) - 5000
	backupTime2 = backupTime1 + 5000
	settings = Settings()
	index = ()
	
	if settings.AmazonS3Backup == True:
		S3_AccessId = settings.AmazonS3_AccessId
		S3_SecretKey = settings.AmazonS3_SecretKey
	else:
		S3_AccessId = None
		S3_SecretKey = None
	
	if settings.AmazonS3_Location == "European":
		S3_BucketType = settings.AmazonS3_Location
	else:
		S3_BucketType = None
	
	au = ArchiveUrl_FromSettings(folder, settings)
	if au.hostAvailable:
		col_stats, filelist_backend, filelist_archive = duplicity_interface.get_collection_status(str(au.archiveUrl),
			str(au.gnuPassphrase), True, None, S3_AccessId, S3_SecretKey, S3_BucketType)
		result_sets, backup_chain = duplicity_interface.get_backup_sets(col_stats, 
			backupTime1, backupTime2)
		num_vols = 0
		for backupSet in result_sets:
			num_vols += len(backupSet)
			manifest = backupSet.get_manifest()
			volumes = manifest.get_containing_volumes(index)
			
			for vol in volumes:
				print manifest.volume_info_dict[vol]
	
		duplicity_interface.cleanup_globals()
		if S3_AccessId != None and S3_SecretKey != None:
			duplicity_interface.unset_AmazonS3()
		filelist_backend.close()
		duplicity_interface.log.shutdown()
		